// DtL - Derive to LaTeX by Gary Bishop 29 June 1999

/* $Id: Str.h,v 1.1 1999-07-01 11:03:10-04 gb Exp gb $ */

#ifndef STR_H
#define STR_H

// a simple "value" string class
// nothing fancy, strings are copied everywhere so that variables never share storage

#include <string.h>

class Str {
  char* p;
  int len;

  Str(int n);
 public:
  Str();
  Str(const Str& s);
  Str(const char* s);
  Str(char);
  Str mkStr(int n) { return Str(n); }

  ~Str();

  Str operator=(const Str& a);
  Str operator=(const char* a);

  int length() const { return len; }
  operator char* () { return p; }
  operator const char* () const { return p; }

  friend Str operator+(const Str& a, const Str& b); 
  Str operator+=(const Str& a);
  friend Str operator*(const Str& a, int n); // replicate the string
  friend Str operator*(int n, const Str& a) { return a*n; }
  char& operator[](int i);
};

// these apply the corresponding function from ctype.h to the entire string
int isalllower(const Str&);
int isallupper(const Str&);
int isallalnum(const Str&);
int isallascii(const Str&);

#endif
